﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Msdn.ErrorUx
{
    public partial class ErrorMessage : Form
    {
        public ErrorMessage()
        {
            InitializeComponent();
        }

        public static void Show(Exception relatedException)
        {
            ErrorMessage em = new ErrorMessage();
            if (relatedException == null)
            {
                em.problemDetailsContainer.Visible = false;
            }
            else
            {
                em.problemDescription.Text = relatedException.Message;
                IUIExceptionDetail detail = relatedException as IUIExceptionDetail;
                if (detail == null)
                {
                    em.errorCode.Text = "500";
                    em.problemDetails.Visible = false;
                }
                else
                {
                    em.errorCode.Text = detail.ErrorCode.ToString();
                    em.problemDetails.Text = detail.DetailMessage;
                    // em.problemDetailsContainer.IsCollapsed = true; // seems to break it
                    // need to get a better progressive disclosure control
                    // one that dynamically resizes the form when expanded/collapsed
                }
                em.problemType.Text = em.GetMeaningfulExceptionType(relatedException).Name;
                em._SearchText = em.errorCode.Text + " " + em.problemType.Text;
            }
            em.ShowDialog();
        }

        // tries to find the first meaningful exception type
        // i.e., one that is not just "Exception", which is 
        // what the policy might return just to bubble a friendly 
        // message
        Type GetMeaningfulExceptionType(Exception ex)
        {
            Type exType = ex.GetType();
            if (exType == typeof(Exception) &&
                ex.InnerException != null)
                return GetMeaningfulExceptionType(ex.InnerException);
            return exType;
        }

        string _SearchText = string.Empty;


        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void linkLabel3_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start(
                string.Format(
                 "http://search.live.com/results.aspx?q={0}",
                 "FunBoox " + _SearchText));
        }
    }
}
